(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('searchable-json-viewer', ['exports', '@angular/core', '@angular/common', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['searchable-json-viewer'] = {}, global.ng.core, global.ng.common, global.ng.forms));
}(this, (function (exports, i0, common, forms) { 'use strict';

    var SearchableJsonViewerService = /** @class */ (function () {
        function SearchableJsonViewerService() {
        }
        return SearchableJsonViewerService;
    }());
    SearchableJsonViewerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SearchableJsonViewerService_Factory() { return new SearchableJsonViewerService(); }, token: SearchableJsonViewerService, providedIn: "root" });
    SearchableJsonViewerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    SearchableJsonViewerService.ctorParameters = function () { return []; };

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise, SuppressedError, Symbol */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
        function accept(f) { if (f !== void 0 && typeof f !== "function")
            throw new TypeError("Function expected"); return f; }
        var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
        var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
        var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
        var _, done = false;
        for (var i = decorators.length - 1; i >= 0; i--) {
            var context = {};
            for (var p in contextIn)
                context[p] = p === "access" ? {} : contextIn[p];
            for (var p in contextIn.access)
                context.access[p] = contextIn.access[p];
            context.addInitializer = function (f) { if (done)
                throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
            var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
            if (kind === "accessor") {
                if (result === void 0)
                    continue;
                if (result === null || typeof result !== "object")
                    throw new TypeError("Object expected");
                if (_ = accept(result.get))
                    descriptor.get = _;
                if (_ = accept(result.set))
                    descriptor.set = _;
                if (_ = accept(result.init))
                    initializers.unshift(_);
            }
            else if (_ = accept(result)) {
                if (kind === "field")
                    initializers.unshift(_);
                else
                    descriptor[key] = _;
            }
        }
        if (target)
            Object.defineProperty(target, contextIn.name, descriptor);
        done = true;
    }
    ;
    function __runInitializers(thisArg, initializers, value) {
        var useValue = arguments.length > 2;
        for (var i = 0; i < initializers.length; i++) {
            value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
        }
        return useValue ? value : void 0;
    }
    ;
    function __propKey(x) {
        return typeof x === "symbol" ? x : "".concat(x);
    }
    ;
    function __setFunctionName(f, name, prefix) {
        if (typeof name === "symbol")
            name = name.description ? "[".concat(name.description, "]") : "";
        return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    }
    ;
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }
    function __addDisposableResource(env, value, async) {
        if (value !== null && value !== void 0) {
            if (typeof value !== "object" && typeof value !== "function")
                throw new TypeError("Object expected.");
            var dispose;
            if (async) {
                if (!Symbol.asyncDispose)
                    throw new TypeError("Symbol.asyncDispose is not defined.");
                dispose = value[Symbol.asyncDispose];
            }
            if (dispose === void 0) {
                if (!Symbol.dispose)
                    throw new TypeError("Symbol.dispose is not defined.");
                dispose = value[Symbol.dispose];
            }
            if (typeof dispose !== "function")
                throw new TypeError("Object not disposable.");
            env.stack.push({ value: value, dispose: dispose, async: async });
        }
        else if (async) {
            env.stack.push({ async: true });
        }
        return value;
    }
    var _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
        var e = new Error(message);
        return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };
    function __disposeResources(env) {
        function fail(e) {
            env.error = env.hasError ? new _SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
            env.hasError = true;
        }
        function next() {
            while (env.stack.length) {
                var rec = env.stack.pop();
                try {
                    var result = rec.dispose && rec.dispose.call(rec.value);
                    if (rec.async)
                        return Promise.resolve(result).then(next, function (e) { fail(e); return next(); });
                }
                catch (e) {
                    fail(e);
                }
            }
            if (env.hasError)
                throw env.error;
        }
        return next();
    }
    var tslib_es6 = {
        __extends: __extends,
        __assign: __assign,
        __rest: __rest,
        __decorate: __decorate,
        __param: __param,
        __metadata: __metadata,
        __awaiter: __awaiter,
        __generator: __generator,
        __createBinding: __createBinding,
        __exportStar: __exportStar,
        __values: __values,
        __read: __read,
        __spread: __spread,
        __spreadArrays: __spreadArrays,
        __spreadArray: __spreadArray,
        __await: __await,
        __asyncGenerator: __asyncGenerator,
        __asyncDelegator: __asyncDelegator,
        __asyncValues: __asyncValues,
        __makeTemplateObject: __makeTemplateObject,
        __importStar: __importStar,
        __importDefault: __importDefault,
        __classPrivateFieldGet: __classPrivateFieldGet,
        __classPrivateFieldSet: __classPrivateFieldSet,
        __classPrivateFieldIn: __classPrivateFieldIn,
        __addDisposableResource: __addDisposableResource,
        __disposeResources: __disposeResources,
    };

    var SearchableJsonViewerComponent = /** @class */ (function () {
        function SearchableJsonViewerComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.expandedNodes = new Set();
            this.searchTerm = '';
            this.navigateId = 0;
            this.totalHighlightsSize = 0;
            this.makeExpandable = function (data) {
                try {
                    if (typeof data === "object" && !Array.isArray(data)) {
                        // If it's an object, add it to the Set
                        _this.expandedNodes.add(data);
                        // Recursively traverse the object's properties
                        for (var key in data) {
                            _this.makeExpandable(data[key]);
                        }
                    }
                    else if (Array.isArray(data)) {
                        // If it's an array, add it to the Set
                        _this.expandedNodes.add(data);
                        // Recursively traverse the array's elements
                        data.forEach(function (item) {
                            _this.makeExpandable(item);
                        });
                    }
                }
                catch (ex) {
                    console.log("Error in makeExpandable::" + ex);
                }
            };
            this.isCheckCondition = function (value) {
                if (_this.isObject(value) || _this.isArray(value)) {
                    return _this.isNodeExpanded(value);
                }
                else {
                    return true;
                }
            };
            this.next = function () {
                if (_this.searchTerm.length > 0) {
                    var highlightedSpans = document.querySelectorAll("span.highlight");
                    if (Number(_this.navigateId) < highlightedSpans.length) {
                        _this.navigateId++;
                        highlightedSpans.forEach(function (span) {
                            if (span) {
                                var spanId = span.getAttribute("id");
                                if (Number(spanId) === Number(_this.navigateId)) {
                                    span.classList.add("navigator-bg");
                                    span.scrollIntoView({ behavior: 'smooth', block: 'center' });
                                }
                                else {
                                    span.classList.remove("navigator-bg");
                                }
                            }
                        });
                    }
                    //Commented for temeraory which is used to loop purpose
                    // if(highlightedSpans.length < Number(this.navigateId)){
                    //   this.navigateId = 0;
                    //   this.next();
                    // }
                }
            };
            this.prev = function () {
                if (_this.searchTerm.length > 0) {
                    if (_this.navigateId > 1) {
                        _this.navigateId--;
                        var highlightedSpans = document.querySelectorAll("span.highlight");
                        highlightedSpans.forEach(function (span) {
                            if (span) {
                                var spanId = span.getAttribute("id");
                                if (Number(spanId) === Number(_this.navigateId)) {
                                    span.classList.add("navigator-bg");
                                    span.scrollIntoView({ behavior: 'smooth', block: 'center' });
                                }
                                else {
                                    span.classList.remove("navigator-bg");
                                }
                            }
                        });
                    }
                }
            };
            this.getTotalHighlights = function () {
                var highlightedSpans = document.querySelectorAll("span.highlight");
                var size = highlightedSpans.length;
                return size;
            };
        }
        SearchableJsonViewerComponent.prototype.handleKeyPress = function (event) {
            if (event.ctrlKey && event.altKey && event.which == 70) {
                var txt = window.getSelection();
                var searchTerm = txt.toString();
                this.searchJson(searchTerm);
            }
        };
        SearchableJsonViewerComponent.prototype.ngOnInit = function () {
            this.makeExpandable(this.json);
        };
        SearchableJsonViewerComponent.prototype.ngAfterContentChecked = function () {
            this.totalHighlightsSize = this.getTotalHighlights();
            this.cdr.detectChanges();
        };
        SearchableJsonViewerComponent.prototype.isObject = function (value) {
            var type = typeof value === 'object' && value !== null && !Array.isArray(value);
            return type;
        };
        SearchableJsonViewerComponent.prototype.isArray = function (value) {
            return Array.isArray(value);
        };
        SearchableJsonViewerComponent.prototype.getObjectKeys = function (obj) {
            var keys = Object.keys(obj);
            return keys;
        };
        SearchableJsonViewerComponent.prototype.toggleNode = function (node) {
            var _this = this;
            if (this.expandedNodes.has(node)) {
                this.expandedNodes.delete(node);
            }
            else {
                this.expandedNodes.add(node);
                //open all the element from the heirarichy
                this.makeExpandable(node);
            }
            setTimeout(function () {
                if (_this.searchTerm.length > 0) {
                    var highlightedSpans = document.querySelectorAll("span.highlight");
                    highlightedSpans.forEach(function (span) {
                        span.parentNode.replaceChild(document.createTextNode(span.textContent), span);
                    });
                    _this.searchJson(_this.searchTerm);
                }
            }, 10);
        };
        SearchableJsonViewerComponent.prototype.isNodeExpanded = function (node) {
            return this.expandedNodes.has(node);
        };
        SearchableJsonViewerComponent.prototype.searchJson = function (searchText) {
            var e_1, _a, e_2, _b;
            var spanTexts = document.querySelectorAll(".segment-value");
            if (searchText !== this.searchTerm) { //implemented when typing
                var highlightedSpans = document.querySelectorAll("span.highlight");
                highlightedSpans.forEach(function (span) {
                    span.parentNode.replaceChild(document.createTextNode(span.textContent), span);
                });
                //clear all the items
                if (searchText === '') {
                    this.searchTerm = searchText;
                    return;
                }
            }
            var highlightedSpanTexts = [];
            try {
                for (var spanTexts_1 = __values(spanTexts), spanTexts_1_1 = spanTexts_1.next(); !spanTexts_1_1.done; spanTexts_1_1 = spanTexts_1.next()) {
                    var spanElement = spanTexts_1_1.value;
                    var text = spanElement.innerHTML;
                    if (text.toLowerCase().indexOf(searchText.toLowerCase()) > -1) {
                        highlightedSpanTexts.push(spanElement);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (spanTexts_1_1 && !spanTexts_1_1.done && (_a = spanTexts_1.return)) _a.call(spanTexts_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            var index = 0;
            try {
                for (var highlightedSpanTexts_1 = __values(highlightedSpanTexts), highlightedSpanTexts_1_1 = highlightedSpanTexts_1.next(); !highlightedSpanTexts_1_1.done; highlightedSpanTexts_1_1 = highlightedSpanTexts_1.next()) {
                    var content = highlightedSpanTexts_1_1.value;
                    var text = content.innerHTML;
                    var highlightedText = text.replace(new RegExp(searchText, 'gi'), function (match) { return "<span id=" + (index + 1) + " class=\"highlight\">" + match + "</span>"; });
                    content.innerHTML = highlightedText;
                    index++;
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (highlightedSpanTexts_1_1 && !highlightedSpanTexts_1_1.done && (_b = highlightedSpanTexts_1.return)) _b.call(highlightedSpanTexts_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            this.searchTerm = searchText;
        };
        return SearchableJsonViewerComponent;
    }());
    SearchableJsonViewerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'searchable-json-viewer',
                    template: "\n    <div\n    class=\"header\">\n      <input \n      class=\"input-custom\"\n      type=\"text\" \n      [ngModel]=\"searchTerm\" \n      (ngModelChange)=\"searchJson($event)\" \n      placeholder=\"Search JSON\">\n      <div class=\"action-container\">\n        <div class=\"segment-key\" *ngIf=\"totalHighlightsSize > 0\">\n          {{navigateId + '/' + totalHighlightsSize}}\n        </div>\n        <button class=\"btn prev-button\" (click)=\"prev()\">&#x2039;</button>\n        <button class=\"btn next-button\" (click)=\"next()\">&#x203A;</button>\n      </div>\n    </div>\n    \n    <div class=\"json-viewer-container\">\n      <ng-container \n      [ngTemplateOutlet]=\"renderNode\" \n      [ngTemplateOutletContext]=\"{ \n        $implicit: {\n          node: json\n        } \n      }\"></ng-container>\n    </div>\n    <ng-template #renderNode let-data>\n      <div \n      class=\"section-node\"\n      style=\"margin-left: 24px;\"\n      *ngIf=\"isObject(data.node)\">\n        <div *ngFor=\"let key of getObjectKeys(data.node)\">\n          <span \n          class=\"arrow\"\n          *ngIf=\"isObject(data.node[key]) || isArray(data.node[key])\"\n          [ngClass]=\"{'down-arrow': isNodeExpanded(data.node[key]), 'right-arrow': !isNodeExpanded(data.node[key])}\"\n          (click)=\"toggleNode(data.node[key])\">&#x27A4;</span>\n          <strong class=\"segment-key\">{{ key }}: </strong>\n          <ng-container \n          *ngIf=\"isCheckCondition(data.node[key])\"\n          [ngTemplateOutlet]=\"renderNode\"\n          [ngTemplateOutletContext]=\"{ \n            $implicit: {\n              node: data.node[key]\n            } \n          }\"></ng-container>\n        </div>\n      </div>\n      <div *ngIf=\"isArray(data.node)\">\n        <div \n        style=\"margin-left: 12px;\"\n        *ngFor=\"let item of data.node; let i = index\">\n          <span \n          class=\"arrow\"\n          *ngIf=\"isObject(item) || isArray(item)\"\n          [ngClass]=\"{'down-arrow': isNodeExpanded(item), 'right-arrow': !isNodeExpanded(item)}\"\n          (click)=\"toggleNode(item)\">&#x27A4;</span>\n          <strong class=\"segment-key\">{{ i + ': ' }}</strong>\n          <!--following span only applicable for array of string or array of intergers Begin-->\n          <span \n          *ngIf=\"!isObject(item) && !isArray(item)\" \n          class=\"segment-value\">\n            {{ item | jsonValue }}\n          </span>\n          <!--End-->\n          <ng-container \n          *ngIf=\"isNodeExpanded(item)\"\n          [ngTemplateOutlet]=\"renderNode\"\n          [ngTemplateOutletContext]=\"{ \n            $implicit: {\n              node: item\n            } \n          }\"></ng-container>\n        </div>\n      </div>\n      <span\n      *ngIf=\"!isObject(data.node) && !isArray(data.node)\" \n      class=\"segment-value\">\n        {{ data.node | jsonValue }}\n      </span>\n    </ng-template>  \n  ",
                    styles: [".json-viewer-container{margin:10px 0 0}.json-viewer-container .segment-key{color:#6c5e5e;font-family:Arial,Helvetica,sans-serif;font-size:12px}.json-viewer-container .segment-value{color:#f78c6c;font-family:Arial,Helvetica,sans-serif;font-size:12px}.json-viewer-container ::ng-deep .highlight{background:#ff0}.json-viewer-container ::ng-deep .navigator-bg{background:#fdbb04!important}.json-viewer-container .section-node:first-child{margin-left:0!important}.json-viewer-container .arrow{cursor:pointer;margin-right:5px;font-size:12px;color:#6c5e5e;-moz-user-select:none;-webkit-user-select:none;user-select:none}.json-viewer-container .down-arrow{transform:rotate(90deg);display:inline-block}.json-viewer-container .right-arrow{transform:none}.header{position:sticky;top:0;background:#fff;padding:10px;z-index:2;display:flex;border-radius:2px;border:1px solid #dcdcdc;gap:5px;align-items:center;justify-content:space-between}.header .action-container{display:flex;align-items:center;gap:10px}.header .action-container .btn{background:transparent;border:none;cursor:pointer;color:#6c5e5e;font-size:20px}.header .action-container .btn:active{transform:scale(.98);box-shadow:3px 2px 22px 1px rgba(0,0,0,.24)}.header .input-custom{outline:none;border:none;width:50%}.header .segment-key{color:#6c5e5e;font-family:Arial,Helvetica,sans-serif;font-size:12px}"]
                },] }
    ];
    SearchableJsonViewerComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef }
    ]; };
    SearchableJsonViewerComponent.propDecorators = {
        json: [{ type: i0.Input }],
        handleKeyPress: [{ type: i0.HostListener, args: ['document:keydown', ['$event'],] }]
    };

    var JsonValuePipe = /** @class */ (function () {
        function JsonValuePipe() {
        }
        JsonValuePipe.prototype.transform = function (value) {
            return isNaN(value) ? JSON.stringify(value) : value;
        };
        return JsonValuePipe;
    }());
    JsonValuePipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'jsonValue'
                },] }
    ];

    var SearchableJsonViewerModule = /** @class */ (function () {
        function SearchableJsonViewerModule() {
        }
        return SearchableJsonViewerModule;
    }());
    SearchableJsonViewerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        SearchableJsonViewerComponent,
                        JsonValuePipe
                    ],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [
                        SearchableJsonViewerComponent
                    ]
                },] }
    ];

    /*
     * Public API Surface of searchable-json-viewer
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SearchableJsonViewerComponent = SearchableJsonViewerComponent;
    exports.SearchableJsonViewerModule = SearchableJsonViewerModule;
    exports.SearchableJsonViewerService = SearchableJsonViewerService;
    exports.ɵa = JsonValuePipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=searchable-json-viewer.umd.js.map
